
% searches for best chi square for one particular participant
% x y represent the data (see main1)
function chi = fitr1(parm);

%CONSTANT
global nt np                                %number of trials and parameters (no need for ns)
global lba uba lbb1 ubb1 lbc ubc 	%Needed for rescaling of raster

%VARIABLE 
global x y                                 %subject data; specified in main1 and need for global passing
  


% ************************************************************************
%Rescaling: Needs to be changed only if np changes
if np==3
    aa=parm(1,1); bb1 = parm(2,1); cc = parm(3,1);  %dummy variables
    %Rescaling back to model parameters (we are now in the inner part of the optimization process)
    a = scalei(uba,lba,aa);   
    b1 = scalei(ubb1,lbb1,bb1); 
    c = scalei(ubc,lbc,cc);
else
   'Error number of parameters different from implementation'
end
% ************************************************************************



%---DIGITAL FILTER TECHNIQUE------------
%This small section was added by Anthony Bishara.
%It eliminates the need for trial looping by using a digital filter.
%Ryan Jessup created the function "fastrln," which is useful for
%n-armed bandit reinforcement learning models.  The function transforms
%information and calls the built-in MatLab function, "filter."  Kudos to
%Ryan for this idea - it makes the program almost 10 times as fast!
winvec=abs(x(:,2))/100;
lossvec=abs(x(:,3))/100;
vtvec=(1-b1)*winvec - b1*lossvec; %Vector of valences of choices
choicevtmat=[x(:,1) vtvec]; %col1=choice, col2=vector of valences
evmat=fastrln(0,choicevtmat,a,4); %DIGITAL FILTER CALL
gamvec=((1:nt)'./10).^c;
smat=exp(evmat.*[gamvec gamvec gamvec gamvec]) + .0000000001;
rowsumsmat=sum(smat')' ;
pmat=smat./[rowsumsmat rowsumsmat rowsumsmat rowsumsmat];
ppmat=.0001 + .9998*pmat(1:(nt-1),:);
chifiltermat=log(ppmat).*y(2:nt,:) ;
chi=sum(sum(chifiltermat));
%chifilterstore=chi; %DEBUGGING
%chifiltervec=cumsum(sum(chifiltermat'))' ; %DEBUGGING
%---FILTER TECHNIQUE---------------------

%---TRIAL LOOP TECHNIQUE-----------------------
%chi= 0; 	    %initialize
%v = [0;0;0;0]; 	%initialize
%countdecks=[0 0 0 0]';    %initialize
%close_gate = 0;
%chiloopvec=[]
%begin of training 
%for tt = 2:nt
%    t = tt-1;  
%    yt = y(t,:)';   % current choice just made this choice  
%    countdecks=countdecks+yt;
%    ytt= y(tt,:)';  % the next choice one step ahead we wish to predict
%    xt = x(t,:);    % current payoff just experienced; one row in x, for trial t
    
%    win  = abs(xt(2))/100;                         % Eldad
%    loss = abs(xt(3))/100;                         % determine loss and rescale it

    %v = v + a * yt.* ((1-b1)*win - b1*loss - v); Split into 2 eq for ease
%    vt =(1-b1)*win - b1*loss; %-AJB
%    v=(1-a*yt).*v+a*yt.*vt;
    
%    gam = (t/10)^c;    % sensitivity

%     s = exp(gam*v)+ 0.0000000001;  % strength 
     
%     p = s./sum(s);    % prob of choice for each deck 
  
%     pp = .0001 + .9998*p;
%     chi = chi + log(pp)'*ytt;

%end 
%countdecks=countdecks+ytt;

%end of training
%----------TRIAL LOOP TECHNIQUE----------------------------
chi = -2*chi;% -2 times log likelihood 
